package com.css.simulation.resource.common.controller;

import api.common.pojo.common.ResponseBodyVO;
import api.common.util.ExcelUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

@Slf4j
@RestController
@RequestMapping("/excel")
public class ExcelController {

    @PostMapping(value = "/parse", consumes = MediaType.MULTIPART_FORM_DATA_VALUE)
    public ResponseBodyVO<List<List<String>>> parseExcel(@RequestPart("excel") MultipartFile excel) {
        try {
            String originalFilename = excel.getOriginalFilename();
            log.info("parseExcel() excel 名称为：" + originalFilename);
            String suffix = originalFilename.split("\\.")[1];
            InputStream inputStream = excel.getInputStream();
            Workbook workbook = ExcelUtil.getExcel(inputStream, suffix);
            Sheet sheet = ExcelUtil.getSheetByIndex(workbook, 0);
            List<List<String>> table = ExcelUtil.getTable(sheet, 0, Integer.MAX_VALUE, 0, Integer.MAX_VALUE);
            workbook.close();
            return new ResponseBodyVO<>(ResponseBodyVO.Response.SUCCESS, table);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
