package com.css.simulation.resource.project.mapper;

import api.common.pojo.param.project.SimulationManualProjectParam;
import api.common.pojo.po.algorithm.AlgorithmPO;
import api.common.pojo.po.model.ConfigPO;
import api.common.pojo.po.model.ConfigSensorPO;
import api.common.pojo.po.model.VehiclePO;
import api.common.pojo.po.project.SimulationManualProjectPo;
import api.common.pojo.po.project.SimulationMptFirstTargetScorePo;
import api.common.pojo.po.project.SimulationMptLastTargetScorePo;
import api.common.pojo.po.project.SimulationMptSceneScorePo;
import api.common.pojo.po.scene.ScenePackagePO;
import api.common.pojo.vo.project.*;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Mapper
@Repository
public interface SimulationProjectMapper {

    @Select("select scene\n" +
            "        from simulation_manual_project\n" +
            "        where is_deleted = '0'\n" +
            "          and id = #{id,jdbcType=VARCHAR}")
    String selectSceneById(@Param("id") String id);

    int add(SimulationManualProjectPo po);

    int update(SimulationManualProjectPo po);

    SimulationManualProjectPo selectLastProjectId(Integer nowRq);

    List<SimulationManualProjectPo> selectProject(SimulationManualProjectParam param);

    List<SimulationManualProjectVo> selectProjectList(SimulationManualProjectParam param);

    SimulationManualProjectPo selectProjectById(SimulationManualProjectParam param);

    List<SimulationManualProjectPo> selectProjectByName(SimulationManualProjectParam param);

    SimulationManualProjectPo selectProjectBaseById(SimulationManualProjectParam param);


    int deleteProject(String[] ids);

    int updateProjectNowRunState(SimulationManualProjectParam param);

    List<AlgorithmPO> selectAlgorithmBaseInfoById(AlgorithmPO algorithmPO);

    @Select("select id, algorithm_name, description\n" +
            "        from algorithm\n" +
            "        where id = #{algorithmId}")
    AlgorithmPO selectAlgorithmById(@Param("algorithmId") String algorithmId);

    List<VehiclePO> selectVehicleBaseInfoById(String id);

    List<ScenePackagePO> selectScenePackageBaseById(ScenePackagePO scenePackagePO);

    ScenePackagePO selectScenePackageInfoById(String id);

    List<ConfigSensorPO> selectVehicleSensor(String id);

    SensorBaseInfoVo selectSensorCamera(String id);

    SensorBaseInfoVo selectSensorOgt(String id);

    SensorBaseInfoVo selectSensorLidar(String id);

    SensorBaseInfoVo selectSensorRadar(String id);

    SensorBaseInfoVo selectSensorGps(String id);

    SceneBaseInfoVo selectSceneAccidentById(String id);

    SceneBaseInfoVo selectSceneNatural(String id);

    SceneBaseInfoVo selectSceneGeneralDataById(String id);

    SceneBaseInfoVo selectSceneStandardsRegulations(String id);

    List<ScenePackageSubListVO> selectSubSceneByPid(String id);

    ScenePackageSubListVO selectsublistBySublistId(String id);

    List<ScenePackageSubListVO> selectSubListByPid(String id);

    List<SublistScoreVo> selectsublistByRootId(SimulationManualProjectParam param);

    int insertSimulationMptLastTargetScorePo(SimulationMptLastTargetScorePo po);

    int insertSimulationMptFirstTargetScorePo(SimulationMptFirstTargetScorePo po);

    List<SimulationMptSceneScorePo> selectSceneScore(SimulationMptSceneScorePo po);

    SystemUserVo selectUserById(String id);

    List<ConfigPO> selectConfigVehicle(ConfigPO configPO);

    List<ConfigPO> selectConfigVehicle2(ConfigPO configPO);

    List<ConfigSensorPO> selectConfigSensor(String id);

    List<SimulationManualProjectPo> selectProjectNowRunState(String[] ids);

    List<SublistScoreVo> selectSubScore(SimulationManualProjectParam param);

    List<SublistScoreVo> selectSubScore2(SimulationManualProjectParam param);

    List<Map> selectRunProjectByState(Map map);

    List<Map> selectEvaluationLevel(Map map);

    int insertOtherAlgorithm(AlgorithmPO po);

    int updateOtherAlgorithm(AlgorithmPO po);

    AlgorithmPO selectalgorithmByQuery(AlgorithmPO po);

    SimulationManualProjectPo selectProjectReportIdByAlgorithmId(String algorithmId);


    @Update("update simulation_manual_project\n" +
            "set details = #{details}\n" +
            "where id = #{projectId}")
    void updateDetailsById(@Param("projectId") String projectId, @Param("details") String details);

}
