package com.css.simulation.resource.project.mapper;

import api.common.pojo.param.project.ProjectTaskParam;
import api.common.pojo.param.project.SceneScoreParam;
import api.common.pojo.po.project.ManualProjectTaskPo;
import api.common.pojo.po.project.SimulationMptSceneScorePo;
import api.common.pojo.vo.project.ManualProjectTaskVo;
import api.common.pojo.vo.project.ProjectRunResultRatioNumVo;
import api.common.pojo.vo.project.ProjectRunStateNumVo;
import api.common.pojo.vo.project.SceneScoreVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Mapper
@Repository
public interface SimulationProjectTaskMapper {

    List<ManualProjectTaskPo> selectProjectTask(ProjectTaskParam vo);

    List<ManualProjectTaskVo> selectProjectTaskByProjectId(ProjectTaskParam vo);

    Integer selectProjectTaskNumByProjectId(ProjectTaskParam vo);

    List<ProjectRunStateNumVo> selectRunStateCount(String id);

    List<ProjectRunResultRatioNumVo> selectRunResultCount(String id);

    List<ProjectRunResultRatioNumVo> selectScoreCount(String id);

    List<SceneScoreVo> selectSceneScoreByIds(SceneScoreParam param);

    SceneScoreVo selectSceneScoreNumQuery(SimulationMptSceneScorePo po);

    List<Map> selectRunTaskByState(Map map);

    //更新仿真结果到数据库
    int updateTaksResult(ManualProjectTaskPo po);

    SceneScoreVo selectRunStateByAborted(SimulationMptSceneScorePo po);


    List<ManualProjectTaskVo> selectProjectTaskById(String id);

    @Select("select sum(number)\n" +
            "from (select count(*) number\n" +
            "      from simulation_manual_project_task smpt\n" +
            "               left join simulation_manual_project smp on smpt.p_id = smp.id\n" +
            "               left join model_config mc on smp.vehicle = mc.id\n" +
            "               left join model_vehicle mv on mc.vehicle_id = mv.id\n" +
            "      where smpt.is_deleted = '0'\n" +
            "        and smp.is_deleted = '0'\n" +
            "        and mc.is_deleted = '0'\n" +
            "        and mv.is_deleted = '0'\n" +
            "        and smpt.run_state = 'Running'\n" +
            "        and mv.parameter_type = '2'\n" +
            "      union all\n" +
            "      select count(*) number\n" +
            "      from simulation_manual_project_task smpt\n" +
            "               left join simulation_automatic_subproject sas on smpt.p_id = sas.id\n" +
            "               left join simulation_automatic_project sap on sas.parent_id = sap.id\n" +
            "               left join model_config mc on sap.vehicle = mc.id\n" +
            "               left join model_vehicle mv on mc.vehicle_id = mv.id\n" +
            "      where smpt.is_deleted = '0'\n" +
            "        and sas.is_deleted = '0'\n" +
            "        and sap.is_deleted = '0'\n" +
            "        and mc.is_deleted = '0'\n" +
            "        and mv.is_deleted = '0'\n" +
            "        and smpt.run_state = 'Running'\n" +
            "        and mv.parameter_type = '2') temp\n" +
            ";")
    int selectTaskNumberOfCarsim();


}
