package com.css.simulation.resource.project.service;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.project.SimulationManualProjectParam;
import api.common.pojo.vo.project.*;
import com.github.pagehelper.PageInfo;

import java.util.List;


public interface SimulationProjectService {

    ResponseBodyVO<String> addOrUpdateProject(SimulationManualProjectParam param);

    ResponseBodyVO<PageInfo<SimulationManualProjectVo>> selectProject(SimulationManualProjectParam param);

    ResponseBodyVO selectProjectById(SimulationManualProjectParam param);

    ResponseBodyVO<String> deleteProjectByids(SimulationManualProjectParam param);

    ResponseBodyVO<String> updateProjectNowRunState(SimulationManualProjectParam param);

    ResponseBodyVO<ProjectDetailsVo> selectProjectDetailsById(SimulationManualProjectParam param);

    ResponseBodyVO<ProjectReportVo> selectProjectReportById(SimulationManualProjectParam param);

    ResponseBodyVO<List<DropDownTypeVo>> selectDropDownByType(SimulationManualProjectParam param);

    ResponseBodyVO<ProjectTaskDetailsVo> selectProjectTaskById(SimulationManualProjectParam param);

    ResponseBodyVO selectMaxParallelism();

    String getDictName(String type, String code);

    ResponseBodyVO analysisVehicleCoord() throws Exception;

    ResponseBodyVO selectProjectTaskList(SimulationManualProjectParam param);

    ResponseBodyVO selectRunTaskByState();

    ResponseBodyVO selectRunProjectByState();

    ResponseBodyVO selectEvaluationLevel();

    void exportProjectReport(SimulationManualProjectParam param);

    //根据算法id获取最新的一条报告id
    String selectProjectReportIdByAlgorithmId(String algorithmId);

    // 生成保存评价等级
    ResponseBodyVO<String> saveEvaluationLevel(String id);

    //仿真结果保存到数据库
    ResponseBodyVO saveTaskResult(SimulationManualProjectParam param);

    void exportProjectTaskFileById(SimulationManualProjectParam param);

    void exportProjectReportAndTaskFileById(SimulationManualProjectParam param);

    ResponseBodyVO addOrUpdateAutomaticProject(SimulationManualProjectParam param);

    ResponseBodyVO<String> deleteAutomaticProjectByids(SimulationManualProjectParam param);

    ResponseBodyVO<String> updateAutomaticRunState(SimulationManualProjectParam param);

    ResponseBodyVO<PageInfo<SimulationManualProjectVo>> selectAutomaticProject(SimulationManualProjectParam param);

    ResponseBodyVO<String> createAutomaticSubProject(SimulationManualProjectParam param);

    ResponseBodyVO<String> deleteAutomaticSubProjectByIds(SimulationManualProjectParam param);

    ResponseBodyVO<AutomaticProjectVo> selectSubProjectInfo(SimulationManualProjectParam param);

    ResponseBodyVO<PageInfo<SimulationManualProjectVo>> selectSubProjectList(SimulationManualProjectParam param);

    ResponseBodyVO<SimulationManualProjectSingleVo> selectAutomaticProjectById(SimulationManualProjectParam param);

    ResponseBodyVO<String> updateAutoProjectNowRunState(SimulationManualProjectParam param);

}
