package com.css.simulation.resource.scene.mapper;

import api.common.pojo.param.scene.SceneDeleteParam;
import api.common.pojo.po.scene.ScenePackageSublistPO;
import api.common.pojo.vo.scene.ScenePackageSublistVO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Update;

import java.util.List;


@Mapper
public interface ScenePackageSublistMapper {

    void saveScenePackageSublist(ScenePackageSublistPO params);

    void saveScenePackageSublistAll(List<ScenePackageSublistPO> treeList);

    void deleteScenePackageSublist(String rootId);

    void deleteScenePackageSublistById(String sublistId);

    List<ScenePackageSublistVO> queryScenePackageSublistList(ScenePackageSublistPO params);

    //指标名查唯一
    List<ScenePackageSublistVO> queryBySublistName(ScenePackageSublistPO params);


    List<String> selectPackageIdById(SceneDeleteParam param);
    List<ScenePackageSublistPO> selectPackageFhById(SceneDeleteParam param);


    void updateScenePackageSublistById(SceneDeleteParam param);

    @Update("update scene_package_sublist\n" +
            "set scene_num = scene_num - 1\n" +
            "where scene_natural_ids like concat('%', #{naturalId}, '%')")
    void updateSceneNumAfterDeleteSceneByNaturalId(@Param("naturalId") String naturalId);

    @Update("update scene_package_sublist\n" +
            "set scene_num = scene_num - 1\n" +
            "where scene_statue_ids like concat('%', #{sceneId}, '%')")
    void updateSceneNumAfterDeleteSceneByStandardsId(@Param("sceneId")String sceneId);

    @Update("update scene_package_sublist\n" +
            "set scene_num = scene_num - 1\n" +
            "where scene_traffic_ids like concat('%', #{sceneId}, '%')")
    void updateSceneNumAfterDeleteSceneByAccidentId(@Param("sceneId")String sceneId);
}
