package com.css.simulation.resource.scene.service;

import api.common.pojo.param.scene.ScoringRulesParam;
import api.common.pojo.po.scene.ScoringRulesPO;
import api.common.util.LogUtil;
import api.common.util.StringUtil;
import api.common.util.TimeUtil;
import com.css.simulation.resource.common.utils.AuthUtil;
import com.css.simulation.resource.scene.mapper.ScoringRulesMapper;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import java.util.List;

@Slf4j
@Service
public class ScoringRulesService {

    @Resource
    private ScoringRulesMapper scoringRulesMapper;

    /**
     * 打分规则数据录入：
     */
    @SneakyThrows
    public void saveScoringRules(ScoringRulesPO params) {
        params.setCreateTime(TimeUtil.getNowForMysql());
        params.setModifyTime(TimeUtil.getNowForMysql());
        params.setRulesId(StringUtil.getRandomUUID());
        params.setRulesCode(StringUtil.getRandomCode());
        params.setCreateUserId(AuthUtil.getCurrentUserId());
        params.setIsDeleted("0");
        scoringRulesMapper.saveScoringRules(params);
        LogUtil.insert();
    }

    @SneakyThrows
    public List<ScoringRulesPO> queryScoringRulesListCSB(ScoringRulesParam params) {
        if (params != null && params.getShare() != null && params.getShare().equals("0")) {
            params.setCreateUserId(AuthUtil.getCurrentUserId());
        }
        List<ScoringRulesPO> list = scoringRulesMapper.queryScoringRulesList(params);

        //查询共有
        params.setCreateUserId("");
        params.setShare("1");
        List<ScoringRulesPO> list1 = scoringRulesMapper.queryScoringRulesList(params);
        list.addAll(list1);
        return list;
    }

    @SneakyThrows
    public List<ScoringRulesPO> queryScoringRulesList(ScoringRulesParam params) {
        if (params != null && params.getShare() != null && params.getShare().equals("0")) {
            params.setCreateUserId(AuthUtil.getCurrentUserId());
        }
        return scoringRulesMapper.queryScoringRulesList(params);
    }


    @SneakyThrows
    public ScoringRulesPO queryScoringRules(ScoringRulesParam params) {
        return scoringRulesMapper.queryScoringRules(params);
    }

    @SneakyThrows
    public ScoringRulesPO queryScoringRulesByRuleName(ScoringRulesParam params) {
        return scoringRulesMapper.queryScoringRulesByRuleName(params);
    }

    @SneakyThrows
    public ScoringRulesPO querySelfOnly(String ruleName,String createUserId) {
        return scoringRulesMapper.querySelfOnly(ruleName,createUserId);
    }

    @SneakyThrows
    public void updateScoringRules(ScoringRulesPO params) {
        params.setModifyTime(TimeUtil.getNowForMysql());
        params.setModifyUserId(AuthUtil.getCurrentUserId());
        scoringRulesMapper.updateScoringRules(params);
        LogUtil.update();
    }

    @SneakyThrows
    public void deleteScoringRules(ScoringRulesPO params) {
        params.setIsDeleted("1");
        params.setModifyTime(TimeUtil.getNowForMysql());
        params.setModifyUserId(AuthUtil.getCurrentUserId());
        scoringRulesMapper.updateScoringRules(params);
        LogUtil.delete();
    }

    @SneakyThrows
    public Integer queryCsbById(ScoringRulesParam params) {

        Integer num = scoringRulesMapper.queryCsbById(params);
        return num;
    }
}
